'''
	Baseline Analysis of Movie Reviews
	Author : Scott Cambo
'''

from p3lib import *
import sys
import os
from numpy import mean

lbMain = '<><><><><><><><><><><><><><><><><><><><><><><><>'
lbMax =  '================================================'
lbMin =  '-----------------------'

Dennis_train = 'DennisSchwartz_train.txt'
Dennis_test = 'DennisSchwartz_test.txt'
Scott_train = 'ScottRenshaw_train.txt'
Scott_test = 'ScottRenshaw_test.txt'
numClassTopWords = 5
numOverallWords = 50
observedStates=[]
for x in range(-2,3):
	for y in range(-2,3):
		strr=''
		strr+= str(x) + str(y)
		observedStates.append(strr)

states=['-2','-1','0','1','2']

kFold = 5
#def cross_val_Acc(revs, kFold):
#	accuracyList = []
#	for i in range(1,kFold +1):
#		kSplits = kFold_Split(revs, kFold, i)
#		trainRevs = kSplits[0]
#		valRevs = kSplits[1]


print lbMain
print "Importing Dennis Schwartz Data"
dennis_revs = read_reviews(Dennis_train)
print "Dennis Schwartz imported"
print "Importing Scott Renshaw Data"
scott_revs = read_reviews(Scott_train)
print "Scott Renshaw data imported"

print lbMax
print "Generate Dennis Schwartz Corpus from training data"
dennis_corpus = gen_corpus(Dennis_train)
print "Generate Scott Renshaw Corpus from training data"
scott_corpus = gen_corpus(Scott_train)
posWords= getWordLists('positiveWords.txt')
negWords= getWordLists('positiveWords.txt')
# Cross-Validation Section
dennis_accuracyList = []
scott_accuracyList = []

print lbMax
print "Starting " + str(kFold) + " Cross-Validation"
print lbMax
for i in range(0, kFold):
	scottLabeled_sequences=[]
	dennisLabeled_sequences=[]
	Dennis_kSplits = kFold_Split(dennis_revs, kFold, i)
	Dennis_train = Dennis_kSplits[0]
	Dennis_val = Dennis_kSplits[1]

	Scott_kSplits = kFold_Split(scott_revs, kFold, i)
	Scott_train = Scott_kSplits[0]
	Scott_val = Scott_kSplits[1]
	dennis_gPred = classifyByWords(posWords, negWords, Dennis_train)
	scott_gPred = classifyByWords(posWords, negWords, Scott_train)
	dennis_hPred = classifyByWords(posWords, negWords, Dennis_val)
	scott_hPred = classifyByWords(posWords, negWords, Scott_val)
	print lbMax
	print "Starting " + str(i)  + "th fold computation"
	print lbMin
	print "Compute baseline features for Dennis using all training data"
	dennis_topW = baseline_features(Dennis_train, numClassTopWords, dennis_corpus, numOverallWords)
	print "Compute baseline features for Scott using all training data"
	scott_topW = baseline_features(Scott_train, numClassTopWords, scott_corpus, numOverallWords)

	print lbMin
	print "Get sentiment tags from Dennis"
	dennis_aPred = review_tagSequences(Dennis_val)
	print "Get sentiment tags from Scott"
	scott_aPred = review_tagSequences(Scott_val)

	print lbMin
	print "Generate baseline predictions for Dennis"
	dennis_bPred = baseline_prediction(dennis_topW, Dennis_train)
	print "Generate baseline predictions for Scott"
	scott_bPred = baseline_prediction(scott_topW, Scott_train)
	
	print lbMin
	print "Generate baseline predictions for Dennis"
	dennis_tPred = baseline_prediction(dennis_topW, Dennis_val)
	print "Generate baseline predictions for Scott"
	scott_tPred = baseline_prediction(scott_topW, Scott_val)

	print lbMin
	print "Compute accuracy for Dennis classifier"
	print "bPred : " + str(len(scott_bPred)) + ", gPred : " + str(len(scott_gPred))
	trainer=nltk.tag.hmm.HiddenMarkovModelTrainer(states, observedStates)
	scottObserved= addBases(scott_bPred, scott_gPred)
	dennisObserved= addBases(dennis_bPred, dennis_gPred)
	#print str(len(scott_aPred))
	for i in range(len(scott_aPred)):
		scottLabeled_sequences.append(zip(scottObserved[i],scott_aPred[i]))
	# str(len(dennis_aPred))
	for i in range(len(dennis_aPred)):
		dennisLabeled_sequences.append(zip(dennisObserved[i],dennis_aPred[i]))
	taggerScott = trainer.train_supervised(scottLabeled_sequences)
	taggerDennis = trainer.train_supervised(dennisLabeled_sequences)
	scottTest=addBases(scott_tPred, scott_hPred)
	dennisTest=addBases(dennis_tPred, dennis_hPred)
	print "dennis test length: " + str(len(dennisTest))
	scottTagged=taggerScott.batch_tag(scottTest)
	dennisTagged=taggerDennis.batch_tag(dennisTest)
	print " after batch tag: " + str(len(dennisTagged))
	scottTaggedlist= taggedToTest(scottTagged)
	dennisTaggedlist= taggedToTest(dennisTagged)
	print str(len(dennisTaggedlist))
	dennis_acc = accuracy(dennis_aPred, dennisTaggedlist)
	dennis_accuracyList.append(dennis_acc)
	print "Compute accuracy for Scott classifier"
	scott_acc = accuracy(scott_aPred, scottTaggedlist)
	scott_accuracyList.append(scott_acc)
	print "\t Dennis : " + str(dennis_acc) + "% accurate"
	print "\t Scott : " + str(scott_acc) + "% accurate"

# compute mean accuracy
print lbMax
dennis_meanAcc = mean(dennis_accuracyList)
scott_meanAcc = mean(scott_accuracyList)
print "Final Mean Accuracy"
print "\t Dennis : " + str(dennis_meanAcc) + "% accurate"
print "\t Scott : " + str(scott_meanAcc) + "% accurate"
